package com.example.afrishop_v3.controllers;

import com.example.afrishop_v3.base.Result;
import com.example.afrishop_v3.enums.ResultCodeEnum;
import com.example.afrishop_v3.models.TbCfUserInfo;
import com.example.afrishop_v3.repository.UserRepository;
import com.example.afrishop_v3.security.services.AuthenticationUser;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("user")
public class UserController {
    private final UserRepository repository;
    private final AuthenticationUser user;

    public UserController(UserRepository repository, AuthenticationUser user) {
        this.repository = repository;
        this.user = user;
    }


    @PutMapping
    public Result updateUser(@RequestBody TbCfUserInfo info) {
        TbCfUserInfo user = this.user.user();

        if (info == null) return new Result(ResultCodeEnum.VALIDATE_ERROR.getCode(), "Empty body");

        if(StringUtils.isNotBlank(info.getAvatar()) ){
            user.setAvatar(info.getAvatar());
        }

        if(StringUtils.isNotBlank(info.getBirthday()) ){
            user.setBirthday(info.getBirthday());
        }

        if(StringUtils.isNotBlank(info.getNick()) ){
            user.setNick(info.getNick());
        }

        if( info.getSex() != null ){
            user.setSex(info.getSex());
        }


        TbCfUserInfo save = repository.save(user);


        return new Result<>(save);

    }
}
